#include "/sys/i386/include/console.h"
#include <err.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	int fd;
	int result;
	scrshot_t shot;
	vid_info_t info;

	if (argc != 2)
		errx(1, "improper # of args");
	fd = open (argv[1], O_RDWR);
	if (fd < 0)
		err(1, "%s: cannot open", argv[1]);
	info.size = sizeof(info);
	result = ioctl (fd, CONS_GETINFO, &info);
	if (result != 0)
		err(1, "getinfo failed");
	shot.buf = malloc(info.mv_csz*info.mv_rsz*sizeof(u_short));
	if (!shot.buf)
		err(1, "couldn't allocate shot");
	shot.xsize = info.mv_csz;
	shot.ysize = info.mv_rsz;
	result = ioctl (fd, CONS_SCRSHOT, &shot);
	if (result != 0)
		err(1, "scrshot failed");
#ifdef USECOLORS
	write(1, shot.buf, shot.xsize*shot.ysize*sizeof(u_short));
#else
	{
		int y;
		for (y = 0; y < shot.ysize; y++) {
			int x;
			for (x = 0; x < shot.xsize; x++)
				putchar(shot.buf[y*80+x] & 0xFF);
			putchar ('\n');
		}
	}
#endif
	return 0;
}
